"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _co = require("co");

var _co2 = _interopRequireDefault(_co);

var _objectCreate = require("./object-create");

var _objectCreate2 = _interopRequireDefault(_objectCreate);

var _fieldSet = require("./field-set");

var _fieldSet2 = _interopRequireDefault(_fieldSet);

var _validate = require("./validate");

var _defaultRules = require("./default-rules");

var _defaultRules2 = _interopRequireDefault(_defaultRules);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Wildgeese = function () {
    _createClass(Wildgeese, null, [{
        key: "is",

        /**
         * Validation an value with default rules.
         * (static method `is`, can not using named custom validation rule.)
         *
         * @static
         * @method is
         * @param {Any} value                       validation target value
         * @param {Array<String|Function>} rules    checking rule name or validator function
         * @return {Promise<Array<String> | undefined}  resolve Error messages when `value` has error. undefined otherwise.
         */
        value: function is(value, rules) {
            var w = new Wildgeese();
            return w.is(value, rules);
        }

        /**
         * @constructor
         * @class Wildgeese
         */

    }]);

    function Wildgeese() {
        _classCallCheck(this, Wildgeese);

        this._config = {};
        this._validators = (0, _objectCreate2.default)();
        this.addRule(_defaultRules2.default);
    }

    /**
     * @class Wildgeese
     */

    _createClass(Wildgeese, [{
        key: "is",

        /**
         * @method is
         * @param {Any} value
         * @param {Array<String|Function>} rules
         * @param {String} label=""
         * @return {Promise<Array<String>>|null} error messages or null when no error.
         */
        value: function is(value) {
            var rules = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
            var label = arguments.length <= 2 || arguments[2] === undefined ? "" : arguments[2];

            return (0, _validate.validateValue)(value, rules, this, { label: label });
        }

        /**
         * @method set
         */

    }, {
        key: "set",
        value: function set(key, value) {
            this._config[key] = value;
        }

        /**
         * @method get
         */

    }, {
        key: "get",
        value: function get(key) {
            if (!key) {
                return _lodash2.default.cloneDeep(this._config);
            }

            return this._config[key];
        }

        /**
         * @param {Object|Array<Object>} rules
         * @param {String} rules.name           validation rule name
         * @param {Function} rules.validate     validator function
         * @param {Boolean} rules.override      override name conflicted rule
         * @param {Boolean} strict=false        throw error rule name is conflicted when true.
         *                                      false to ignore and no adding conflicted rule.
         */

    }, {
        key: "addRule",
        value: function addRule(rules) {
            var _this = this;

            var strict = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

            rules = Array.isArray(rules) ? rules : [rules];

            rules.forEach(function (rule) {
                if (_this._validators[rule.name] && rule.override !== true) {
                    if (strict) {
                        throw new Error("Validation rule name conflicted for \"" + rule.name + "\" " + "if you want overriding, set `override` property in rule definition.");
                    }

                    return;
                }

                _this._validators[rule.name] = _co2.default.wrap(rule.validate);
            });
        }

        /**
         * @param {String} ruleName
         * @return {Function}
         */

    }, {
        key: "getRule",
        value: function getRule(ruleName) {
            return this._validators[ruleName];
        }

        /**
         * @param {Object} <fieldName: rules> field definition `rules` type is `Array<String>|String`
         */

    }, {
        key: "makeFieldSet",
        value: function makeFieldSet() {
            return new _fieldSet2.default(this);
        }
    }, {
        key: "validators",
        get: function get() {
            return _lodash2.default.clone(this._validators);
        }
    }]);

    return Wildgeese;
}();

exports.default = Wildgeese;
module.exports = exports['default'];